<?php if (!defined('PmWiki')) exit();

$ExtendAlpha = "A-Za-z\xc0-\xd6\xd8-\xf6\xf8-\xff";
$CitePattern = "[$ExtendAlpha][-.:0-9$ExtendAlpha]*";
$ReferenceTag = array('o' => '<:block><tbook:references>'.
  (($action=='publish') ? '<tbook:h level="1">Bibliography</tbook:h>' : ''), 
  'c' => '<:block></tbook:references>');

## bib lists
$BlockMarkups['bib'] = array("<tbook:bibliography>\n<tbook:item>",
  '</tbook:item><tbook:item>',"</tbook:item>\n</tbook:bibliography>",1);
Markup('^B:','block','/^B(:)\s?(\s*)/','<:bib,$1,$0>$2');
Markup('^R:','block','/^R:\s*(.*)$/e',
  "'<:block,1><tbook:h level=\"'.
   CitationHeading(\$GLOBALS['HeadingDepth'][\$pagename]).'\">$1</tbook:h>'");
if ($action=='publish') {
    $CiteOpt['title'] = 'References for [[#{$PageAnchor} |{$Title}]]';
    $FmtPV['$PageAnchor'] = '$GLOBALS["PageAnchors"]["$group.$name"]';
}
function CitationHeading($depth) {
  $k = 1;
  foreach (array('section','subsection','subsubsection','paragraph','subparagraph') as $v)
    if ($depth==$v) return $k; else $k++;
  return $k;
}

Markup('cite','inline',
  "/(\*?[Cc])ite(-?[PpTtYy]?)\((?:\"([^\"]*)\"\s*)?($CitePattern)(?:\s*\"([^\"]*)\")?\)/e",
  "('$5'=='*') ? '' : Keep('<tbook:cite refid=\"'.\$pagename.'.'.MakeValidCite('$4').
  '\" kind=\"wiki\">'.
  ReferenceText('$1',('$2' ? '$2' : '*'),'$4',PSS('$3'),PSS('$5')).
  '</tbook:cite>')");
$MarkupFrameBase['posteval']['bib'] =
  "\$out = preg_replace('/(<references>.*?<\/references>)(.*?)$/se',".
      "\"PSS('$2').CitationFooter(\$pagename,PSS('$1'))\",\$out);";

function CitationLabel($label) {
  if (preg_match('/^\[(.*?)\]/',$label,$match))
    return ' style="'.$match[1].'"';
  else return '';
}
function CitationFooter($page,$references) {
  global $HTMLFooterFmt, $LongestCiteKey;
  if (@$LongestCiteKey) $references = str_replace('<bibliography>',
    '<bibliography style="'.$LongestCiteKey.'">',$references);
  $HTMLFooterFmt['bib'] .= preg_replace('/(<item)>([^<]*)<wrap([^>]*)><\/wrap>\s*/e',
    "'$1$3'.CitationLabel('$2').'>'",$references);
  $HTMLFooterFmt['bib'] = preg_replace('/<\/references><references>(<h.*?\/h>)?/',
    '', $HTMLFooterFmt['bib']);
}

?>